#ifndef CHIP_STM32F0XX_REGS_MMAP_H
#define CHIP_STM32F0XX_REGS_MMAP_H

#include "chip_devtype_mem.h"

/* System */
#define CHIP_MEMRGN_ADDR_SYSTEM               0xE0000000UL
#define CHIP_MEMRGN_ADDR_ITM                  (CHIP_MEMRGN_ADDR_SYSTEM + 0x00000000) /* 4K */
#define CHIP_MEMRGN_ADDR_DWT                  (CHIP_MEMRGN_ADDR_SYSTEM + 0x00001000) /* 4K */
#define CHIP_MEMRGN_ADDR_FPB                  (CHIP_MEMRGN_ADDR_SYSTEM + 0x00002000) /* 4K */
#define CHIP_MEMRGN_ADDR_SCS                  (CHIP_MEMRGN_ADDR_SYSTEM + 0x0000E000) /* 4K, System Control Space*/
#define CHIP_MEMRGN_ADDR_TPIU                 (CHIP_MEMRGN_ADDR_SYSTEM + 0x00040000) /* 4K */
#define CHIP_MEMRGN_ADDR_ETM                  (CHIP_MEMRGN_ADDR_SYSTEM + 0x00041000) /* 4K */
#define CHIP_MEMRGN_ADDR_DBGC                 (CHIP_MEMRGN_ADDR_SYSTEM + 0x00042000) /* 1K, Debug Control */
#define CHIP_MEMRGN_ADDR_ROMTABLE             (CHIP_MEMRGN_ADDR_SYSTEM + 0x000FF000) /* 4K  */


/* External Storage */
#define CHIP_MEMRGN_ADDR_QSPI                 0x98000000UL /* 128MB, AHB5, HCLK */
#define CHIP_MEMRGN_ADDR_NFC                  0x88100000UL /*   1MB, AHB5, BCLK */
#define CHIP_MEMRGN_ADDR_DMCR                 0x88000400UL /*   1KB, AHB5, BCLK */
#define CHIP_MEMRGN_ADDR_SMCR                 0x88000000UL /*   1KB, AHB5, BCLK */
#define CHIP_MEMRGN_ADDR_DMC                  0x80000000UL /* 128MB, AHB5, BCLK */
#define CHIP_MEMRGN_ADDR_SMC                  0x60000000UL /* 512MB, AHB5, BCLK */

/* Peripherals */
#define CHIP_MEMRGN_ADDR_BITBAND              0x42000000UL /*  32MB, Peripherals bit banding */
#define CHIP_MEMRGN_ADDR_USBHS                0x400C0000UL /* 256KB, AHB4, PCLK1 */
#define CHIP_MEMRGN_ADDR_USBFS                0x40080000UL /* 256KB, AHB2, PCLK1 */
#define CHIP_MEMRGN_ADDR_SDIOC2               0x40078400UL /*   1KB, AHB2, PCLK1 */
#define CHIP_MEMRGN_ADDR_CAN2                 0x40078000UL /*   1KB, AHB2, PCLK1 */
#define CHIP_MEMRGN_ADDR_SDIOC1               0x40070000UL /*   1KB, AHB3, PCLK1 */
#define CHIP_MEMRGN_ADDR_ETH                  0x40060000UL /*  64KB, AHB3, PCLK1 */
#define CHIP_MEMRGN_ADDR_FMAC(i)             (0x40058000UL + 0x400 * (i)) /* 1KB * 4, AHB1, HCLK */
#define CHIP_MEMRGN_ADDR_DCU(i)              (0x40056000UL + 0x400 * (i)) /* 1KB * 8, AHB1, HCLK */




#define CHIP_MEMRGN_ADDR_FLASH                0x08000000UL
#define CHIP_MEMRGN_ADDR_UID                  0x1FFFF7ACUL /*!< Unique device ID register base address */
#define CHIP_MEMRGN_ADDR_FLASH_SIZE           0x1FFFF7CCUL /*!< FLASH Size register base address */
#define CHIP_MEMRGN_ADDR_OPTION_BYTES         0x1FFF7800UL
#define CHIP_MEMRGN_ADDR_SYSMEM               (CHIP_MEMRGN_ADDR_OPTION_BYTES - CHIP_SYS_MEM_SIZE)


/* RAM */
#define CHIP_MEMRGN_ADDR_SRAM                 0x20000000UL

/* Peripherals */
#define CHIP_MEMRGN_ADDR_APB1                 0x40000000UL
#define CHIP_MEMRGN_ADDR_APB2                 0x40010000UL
#define CHIP_MEMRGN_ADDR_AHB1                 0x40020000UL
#define CHIP_MEMRGN_ADDR_AHB2                 0x48000000UL
#define CHIP_MEMRGN_ADDR_CM0_INTERNAL         0xE0000000UL


/* Адреса блоков периферии */
#define CHIP_MEMRGN_ADDR_PERIPH_TIM2          (CHIP_MEMRGN_ADDR_APB1 + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM3          (CHIP_MEMRGN_ADDR_APB1 + 0x0400)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM6          (CHIP_MEMRGN_ADDR_APB1 + 0x1000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM7          (CHIP_MEMRGN_ADDR_APB1 + 0x1400)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM14         (CHIP_MEMRGN_ADDR_APB1 + 0x2000)
#define CHIP_MEMRGN_ADDR_PERIPH_RTC           (CHIP_MEMRGN_ADDR_APB1 + 0x2800)
#define CHIP_MEMRGN_ADDR_PERIPH_WWDG          (CHIP_MEMRGN_ADDR_APB1 + 0x2C00)
#define CHIP_MEMRGN_ADDR_PERIPH_IWDG          (CHIP_MEMRGN_ADDR_APB1 + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_SPI2          (CHIP_MEMRGN_ADDR_APB1 + 0x3800)
#define CHIP_MEMRGN_ADDR_PERIPH_USART2        (CHIP_MEMRGN_ADDR_APB1 + 0x4400)
#define CHIP_MEMRGN_ADDR_PERIPH_USART3        (CHIP_MEMRGN_ADDR_APB1 + 0x4800)
#define CHIP_MEMRGN_ADDR_PERIPH_USART4        (CHIP_MEMRGN_ADDR_APB1 + 0x4C00)
#define CHIP_MEMRGN_ADDR_PERIPH_USART5        (CHIP_MEMRGN_ADDR_APB1 + 0x5000)
#define CHIP_MEMRGN_ADDR_PERIPH_I2C1          (CHIP_MEMRGN_ADDR_APB1 + 0x5400)
#define CHIP_MEMRGN_ADDR_PERIPH_I2C2          (CHIP_MEMRGN_ADDR_APB1 + 0x5800)
#define CHIP_MEMRGN_ADDR_PERIPH_USB           (CHIP_MEMRGN_ADDR_APB1 + 0x5C00)
#define CHIP_MEMRGN_ADDR_PERIPH_USBCAN_SRAM   (CHIP_MEMRGN_ADDR_APB1 + 0x6000)
#define CHIP_MEMRGN_ADDR_PERIPH_CAN           (CHIP_MEMRGN_ADDR_APB1 + 0x6400)
#define CHIP_MEMRGN_ADDR_PERIPH_CRS           (CHIP_MEMRGN_ADDR_APB1 + 0x6C00)
#define CHIP_MEMRGN_ADDR_PERIPH_PWR           (CHIP_MEMRGN_ADDR_APB1 + 0x7000)
#define CHIP_MEMRGN_ADDR_PERIPH_DAC           (CHIP_MEMRGN_ADDR_APB1 + 0x7400)
#define CHIP_MEMRGN_ADDR_PERIPH_CEC           (CHIP_MEMRGN_ADDR_APB1 + 0x7800)

#define CHIP_MEMRGN_ADDR_PERIPH_SYSCFG        (CHIP_MEMRGN_ADDR_APB2 + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_COMP          (CHIP_MEMRGN_ADDR_APB2 + 0x001C)
#define CHIP_MEMRGN_ADDR_PERIPH_EXTI          (CHIP_MEMRGN_ADDR_APB2 + 0x0400)
#define CHIP_MEMRGN_ADDR_PERIPH_USART6        (CHIP_MEMRGN_ADDR_APB2 + 0x1400)
#define CHIP_MEMRGN_ADDR_PERIPH_USART7        (CHIP_MEMRGN_ADDR_APB2 + 0x1800)
#define CHIP_MEMRGN_ADDR_PERIPH_USART8        (CHIP_MEMRGN_ADDR_APB2 + 0x1C00)
#define CHIP_MEMRGN_ADDR_PERIPH_ADC           (CHIP_MEMRGN_ADDR_APB2 + 0x2400)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM1          (CHIP_MEMRGN_ADDR_APB2 + 0x2C00)
#define CHIP_MEMRGN_ADDR_PERIPH_SPI1          (CHIP_MEMRGN_ADDR_APB2 + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_I2S1          (CHIP_MEMRGN_ADDR_APB2 + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_USART1        (CHIP_MEMRGN_ADDR_APB2 + 0x3800)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM15         (CHIP_MEMRGN_ADDR_APB2 + 0x4000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM16         (CHIP_MEMRGN_ADDR_APB2 + 0x4400)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM17         (CHIP_MEMRGN_ADDR_APB2 + 0x4800)
#define CHIP_MEMRGN_ADDR_PERIPH_DBG           (CHIP_MEMRGN_ADDR_APB2 + 0x5800)

#define CHIP_MEMRGN_ADDR_PERIPH_DMA1          (CHIP_MEMRGN_ADDR_AHB1 + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_DMA2          (CHIP_MEMRGN_ADDR_AHB1 + 0x0400)
#define CHIP_MEMRGN_ADDR_PERIPH_RCC           (CHIP_MEMRGN_ADDR_AHB1 + 0x1000)
#define CHIP_MEMRGN_ADDR_PERIPH_FLASH         (CHIP_MEMRGN_ADDR_AHB1 + 0x2000)
#define CHIP_MEMRGN_ADDR_PERIPH_CRC           (CHIP_MEMRGN_ADDR_AHB1 + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_TSC           (CHIP_MEMRGN_ADDR_AHB1 + 0x4000)

/* Адреса портов */
#define CHIP_MEMRGN_ADDR_PERIPH_GPIO(n)          (CHIP_MEMRGN_ADDR_AHB2 + (0x400*n))
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOA         CHIP_MEMRGN_ADDR_PERIPH_GPIO(0)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOB         CHIP_MEMRGN_ADDR_PERIPH_GPIO(1)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOC         CHIP_MEMRGN_ADDR_PERIPH_GPIO(2)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOD         CHIP_MEMRGN_ADDR_PERIPH_GPIO(3)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOE         CHIP_MEMRGN_ADDR_PERIPH_GPIO(4)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIOF         CHIP_MEMRGN_ADDR_PERIPH_GPIO(5)


#endif // CHIP_STM32F0XX_REGS_MMAP_H
